<template>
  <div class="app-container">
    <el-card>
      <div slot="header">
        <span>物料名称:</span>
        <el-input v-model="materialName" placeholder="物料名称" size="small" clearable/>
        <span>库存状态:</span>
        <el-select v-model="inventoryStateValue" placeholder="库存状态" size="small" clearable>
          <el-option
            v-for="item in inventoryState"
            :key="item.value"
            :label="item.label"
            :value="item.value"/>
        </el-select>
        <span>采购状态:</span>
        <el-select v-model="purchaseStateValue" placeholder="库存状态" size="small">
          <el-option
            v-for="item in purchaseState"
            :key="item.value"
            :label="item.label"
            :value="item.value"/>
        </el-select>
        <el-button
          type="success"
          size="small"
          icon="el-icon-search"
          style="margin-left: 10px"
          @click="pageCurrent1=1;pageSize1=10;total1=0;searchTable1()">查询</el-button>
        <el-button style="float: right; padding: 10px" type="text" @click="showMaterialTable=!showMaterialTable">{{ showMaterialTable ? '收起' : '展开' }}</el-button>
      </div>
      <div v-show="showMaterialTable">
        <el-table
          v-loading="loading1"
          :data="tableData1"
          border
          style="width: 100%;max-height: 460px;"
          height="460"
          size="mini"
          @selection-change="handleSelectionChange">
          <el-table-column type="selection" align="center" width="55"/>
          <el-table-column label="库存状态" width="100" align="center">
            <template slot-scope="scope">
              <el-tag v-if="parseInt(scope.row.库存是否不足)===1" type="danger" size="small">不足</el-tag>
              <el-tag v-else type="success" size="small">充足</el-tag>
            </template>
          </el-table-column>
          <el-table-column label="物料名称" min-width="150" align="center">
            <template slot-scope="scope">
              {{ scope.row.物料名称 }}
            </template>
          </el-table-column>
          <el-table-column label="物料型号" min-width="150" align="center">
            <template slot-scope="scope">
              {{ scope.row.物料型号 }}
            </template>
          </el-table-column>
          <el-table-column label="物料规格" min-width="150" align="center">
            <template slot-scope="scope">
              {{ scope.row.物料规格 }}
            </template>
          </el-table-column>
          <el-table-column label="供货商" min-width="150" align="center">
            <template slot-scope="scope">
              {{ scope.row.供货商 }}
            </template>
          </el-table-column>
          <el-table-column label="当前库存量" min-width="90" align="center">
            <template slot-scope="scope">
              {{ scope.row.当前库存量 }}
            </template>
          </el-table-column>
          <el-table-column label="安全库存量" min-width="200" align="center">
            <template slot-scope="scope">
              <template v-if="scope.row.changeSafeValue">
                <el-input v-model="scope.row.安全库存量" class="edit-input" size="mini"/>
                <el-button class="cancel-btn" size="mini" icon="el-icon-refresh" type="warning" @click="cancelEdit(scope.row)">取消</el-button>
              </template>
              <span v-else>{{ scope.row.安全库存量 }}</span>
            </template>
          </el-table-column>
          <el-table-column label="设置" min-width="100" align="center">
            <template slot-scope="scope">
              <el-button v-if="scope.row.changeSafeValue" type="mini" size="mini" icon="el-icon-circle-check-outline" @click="confirmEdit(scope.row)">确定</el-button>
              <el-button
                v-else
                type="primary"
                size="mini"
                icon="el-icon-edit"
                @click="scope.row.changeSafeValue=!scope.row.changeSafeValue">设置</el-button>
            </template>
          </el-table-column>
        </el-table>
        <div class="block" style="margin-top: 10px;">
          <el-pagination
            :current-page="pageCurrent1"
            :page-sizes="[10, 20, 30, 40]"
            :page-size="pageSize1"
            :total="total1"
            style="display:inline-block;width:50%"
            layout="total, sizes, prev, pager, next, jumper"
            @size-change="handleSizeChange1"
            @current-change="handleCurrentChange1"/>
        </div>
      </div>
    </el-card>

    <el-card>
      <div slot="header">
        <span>离线合同号:</span>
        <el-input v-model="offlineContract" placeholder="离线合同号" size="small" clearable/>
        <span>供应商:</span>
        <el-input v-model="supplierName0" placeholder="供应商" size="small" clearable/>
        <el-button
          type="success"
          size="small"
          icon="el-icon-search"
          style="margin-left: 10px"
          @click="pageCurrent2=1;pageSize2=10;total2=0;searchTable2()">查询</el-button>
        <el-button
          type="primary"
          size="small"
          icon="el-icon-plus"
          style="margin-left: 10px"
          @click="addOfflineContract">创建离线合同</el-button>
        <el-button
          type="primary"
          size="small"
          icon="el-icon-download"
          style="margin-left: 10px"
          @click="addMateriel">选入物料</el-button>
      </div>
      <el-table v-loading="" :data="tableData2" border style="max-height: 460px;" height="300px" size="mini" highlight-current-row @row-click="searchTable3">
        <el-table-column type="expand" fixed="left">
          <template slot-scope="scope">
            <el-form label-position="left" inline class="demo-table-expand">
              <el-form-item label="离线合同备注">
                {{ scope.row.离线合同备注 }}
              </el-form-item>
            </el-form>
          </template>
        </el-table-column>
        <el-table-column label="合同状态" align="center" width="100" fixed="left">
          <template slot-scope="scope">
            <el-tag v-if="Number(scope.row.离线合同状态)===1" type="warning" size="small">编辑中</el-tag>
            <el-tag v-if="Number(scope.row.离线合同状态)===2&&Number(scope.row.总采购数量)!==Number(scope.row.总到货数量)" type="primary" size="small">已采购</el-tag>
            <el-tag v-if="Number(scope.row.总采购数量)===Number(scope.row.总到货数量)&&Number(scope.row.总采购数量)!==0" type="success" size="small">全部到货</el-tag>
          </template>
        </el-table-column>
        <el-table-column label="离线合同编号" align="center" min-width="170">
          <template slot-scope="scope">
            {{ scope.row.离线合同编号 }}
          </template>
        </el-table-column>
        <el-table-column label="离线合同名称" align="center" min-width="170">
          <template slot-scope="scope">
            {{ scope.row.离线合同名称 }}
          </template>
        </el-table-column>
        <el-table-column label="供应商" align="center" min-width="250">
          <template slot-scope="scope">
            {{ scope.row.供应商名称 }}
          </template>
        </el-table-column>
        <el-table-column label="采购员" align="center" min-width="80">
          <template slot-scope="scope">
            {{ scope.row.采购员 }}
          </template>
        </el-table-column>
        <el-table-column label="创建日期" align="center" width="100">
          <template slot-scope="scope">
            {{ scope.row.创建日期.split(' ')[0] }}
          </template>
        </el-table-column>
        <el-table-column label="规定到货时间" align="center" width="100">
          <template slot-scope="scope">
            {{ scope.row.规定到货时间.split(' ')[0] }}
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="240" fixed="right">
          <template slot-scope="scope">
            <el-button :disabled="parseInt(scope.row.离线合同状态)!==1" type="primary" size="mini" @click="editOfflineContract(scope.row)">编辑</el-button>
            <el-button :disabled="parseInt(scope.row.离线合同状态)!==1" type="danger" size="mini" @click="deleteOfflineContract(scope.row)">删除</el-button>
            <el-button type="warning" size="mini" @click="exportExcel(scope.row)">导出</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="block" style="margin: 10px 0;">
        <el-pagination
          :current-page="pageCurrent2"
          :page-sizes="[10, 20, 30, 40]"
          :page-size="pageSize2"
          :total="total2"
          style="display:inline-block;width:50%"
          layout="total, sizes, prev, pager, next, jumper"
          @size-change="handleSizeChange2"
          @current-change="handleCurrentChange2"/>
        <el-button :disabled="disable" type="success" size="mini" style="float:right;margin-left:10px" @click="doneOfflineContact">生成</el-button>
        <el-button :disabled="disable" type="info" size="mini" style="float:right" @click="saveContract">保存</el-button>
      </div>
      <el-table v-loading="" :data="tableData3" :summary-method="getSummaries" border style="max-height: 500px;" height="500px" size="mini" show-summary>
        <el-table-column label="离线合同编号" align="center" min-width="150">
          <template slot-scope="scope">
            {{ scope.row.离线合同编号 }}
          </template>
        </el-table-column>
        <el-table-column label="物料名称" align="center" min-width="150">
          <template slot-scope="scope">
            {{ scope.row.物料名称 }}
          </template>
        </el-table-column>
        <el-table-column label="物料规格" align="center" min-width="100">
          <template slot-scope="scope">
            {{ scope.row.物料规格 }}
          </template>
        </el-table-column>
        <el-table-column label="物料型号" align="center" min-width="200">
          <template slot-scope="scope">
            {{ scope.row.物料型号 }}
          </template>
        </el-table-column>
        <el-table-column label="数量" align="center" min-width="100">
          <template slot-scope="scope">
            <el-input v-model="scope.row.数量" :disabled="disable" size="mini" style="width:70px"/>
          </template>
        </el-table-column>
        <el-table-column label="参考价格" align="center" min-width="100">
          <template slot-scope="scope">
            {{ scope.row.参考价格 }}
          </template>
        </el-table-column>
        <el-table-column label="单价" align="center" min-width="100" prop="单价">
          <template slot-scope="scope">
            <el-input v-model="scope.row.单价" :disabled="disable" size="mini" style="width:70px"/>
          </template>
        </el-table-column>
        <el-table-column label="合计" align="center" min-width="100" prop="合计">
          <template slot-scope="scope">
            {{ (parseFloat(scope.row.单价||0) * parseInt(scope.row.数量||0)).toFixed(2) }}
          </template>
        </el-table-column>
        <el-table-column label="交货期要求" align="center" min-width="100" prop="交货期要求">
          <template slot-scope="scope">
            <el-input v-model="scope.row.交货期要求" :disabled="disable" size="mini" style="width:70px"/>
          </template>
        </el-table-column>
        <el-table-column label="备注" align="center" min-width="150" prop="备注">
          <template slot-scope="scope">
            <el-input v-model="scope.row.备注" :disabled="disable" size="mini" style="width:120px"/>
          </template>
        </el-table-column>
        <el-table-column v-if="disable" label="到货数量" align="center" min-width="100">
          <template slot-scope="scope">
            {{ scope.row.到货数量 }}
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" min-width="100">
          <template slot-scope="scope">
            <el-button :disabled="disable" type="danger" size="mini" icon="el-icon-delete" @click="deleteMateriel(scope.row)">移除</el-button>
          </template>
        </el-table-column>
      </el-table>
    </el-card>

    <el-dialog :visible.sync="dialogVisible1" title="供应商选择" center style="min-height: 300px">
      <el-form ref="form1" :model="form1" label-position="left" label-width="90px" class="searchForm">
        <el-row>
          <el-col :span="12">
            <el-form-item label="供应商名称">
              <el-input v-model="supplierName" size="small"/>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="企业性质">
              <el-input v-model="enterpriseNature" size="small"/>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="货期">
              <el-input v-model="goodTime" size="small"/>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="注册资本">
              <el-input v-model="registeredCapital" size="small"/>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="税号">
              <el-input v-model="taxNum" size="small"/>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="电子邮箱">
              <el-input v-model="EMail" size="small"/>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="地址">
              <el-input v-model="address" size="small"/>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="账号">
              <el-input v-model="account" size="small"/>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="开户行">
              <el-input v-model="openingBank" size="small"/>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="电话号码">
              <el-input v-model="phone" size="small"/>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="传真">
              <el-input v-model="fax" size="small"/>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-button
              type="success"
              size="small"
              icon="el-icon-search"
              @click="searchSupplier">查询</el-button>
            <el-button
              type="primary"
              size="small"
              icon="el-icon-check"
              @click="submitSelectSupplier">确定</el-button>
            <el-button
              type="danger"
              size="small"
              icon="el-icon-delete"
              @click="emptySupplierDetail">清空</el-button>
          </el-col>
        </el-row>
        <el-table :data="tableData01" size="mini" style="width: 97%;max-height: 300px;margin-top:15px" height="200px" border @row-click="showSupplierDetail">
          <el-table-column align="center" label="供应商名称" min-width="250">
            <template slot-scope="scope">
              {{ scope.row.供应商名称 }}
            </template>
          </el-table-column>
          <el-table-column align="center" label="企业性质" min-width="100">
            <template slot-scope="scope">
              {{ scope.row.企业性质 }}
            </template>
          </el-table-column>
          <el-table-column align="center" label="创立日期" min-width="100">
            <template slot-scope="scope">
              {{ scope.row.创立日期 }}
            </template>
          </el-table-column>
          <el-table-column align="center" label="注册资本" min-width="100">
            <template slot-scope="scope">
              {{ scope.row.注册资本 }}
            </template>
          </el-table-column>
        </el-table>
      </el-form>
    </el-dialog>

    <el-dialog :title="title2" :visible.sync="dialogVisible2" center style="min-height: 300px" width="750px">
      <el-form ref="form2" :model="form2" :rules="rules2" label-position="right" label-width="120px">
        <el-row>
          <el-col :span="12">
            <el-form-item label="离线合同编号" prop="离线合同编号">
              <el-input v-model="form2.离线合同编号" size="small"/>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="离线合同名称" prop="离线合同名称">
              <el-input v-model="form2.离线合同名称" size="small"/>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="供应商名称" prop="供应商名称">
              <el-input v-model="form2.供应商名称" size="small" readonly>
                <el-button slot="append" icon="el-icon-search" @click="dialogVisible1=true"/>
              </el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="规定到货时间" prop="规定到货时间">
              <el-date-picker
                v-model="form2.规定到货时间"
                size="small"
                type="date"
                format="yyyy-MM-dd"
                value-format="yyyy-MM-dd"
                placeholder="选择日期"/>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="离线合同备注" prop="离线合同备注">
              <el-input v-model="form2.离线合同备注" size="small" type="textarea" style="width: 550px"/>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button
          v-show="title2==='创建离线合同'"
          type="primary"
          size="small"
          icon="el-icon-check"
          @click="submitAddOfflineContract">确定</el-button>
        <el-button
          v-show="title2==='编辑离线合同'"
          type="primary"
          size="small"
          icon="el-icon-check"
          @click="submitEditOfflineContract">确定</el-button>
      </div>
    </el-dialog>

    <div id="offlineContract" style="width: 800px;margin: 0 auto;display: none">
      <table class="offlineContract" cellspacing="0px" align="center" border="1 solid black" width="100%">
        <tr>
          <th colspan="14"><h1>离线合同</h1></th>
        </tr>
        <tr>
          <td colspan="3" rowspan="2" style="text-align:center;font-size: 30px;font-weight: bold">GAOJING</td>
          <td width="80px">合同名称</td>
          <td id="contractName" colspan="2" style="text-align: left;"/>
          <td width="80px">供应商</td>
          <td id="supplier" colspan="5" style="text-align: left;"/>
          <td id="qrCode" colspan="2" rowspan="2">二维码粘贴处</td>
        </tr>
        <tr>
          <td width="80px">合同编号</td>
          <td id="contractNum" colspan="2" style="text-align: left;"/>
          <td width="80px">采购员</td>
          <td id="buyer" colspan="5" style="text-align: left;"/>
        </tr>
        <tr id="tablehead">
          <td>序号</td>
          <td colspan="2">名称</td>
          <td>规格</td>
          <td colspan="2">型号</td>
          <td>数量</td>
          <td colspan="2">单价</td>
          <td colspan="2">合计</td>
          <td>交货期</td>
          <td colspan="2">备注</td>
        </tr>
        <tr>
          <td>总计</td>
          <td id="remark" colspan="10"/>
          <td id="total" colspan="2" style="text-align: left;"/>
          <td/>
        </tr>
      </table>
    </div>
  </div>
</template>

<script>
import { searchInventoryNum, searchOfflineContract, searchOfflineContract2, searchSupplier, addOfflineContract, editOfflineContract, deleteOfflineContract, searchMateriel,
  addMateriel, deleteMateriel, saveOfflineContact, doneOfflineContact, setSafeValue } from '@/api/PurchasingCenter/OfflineContract'
import QRCode from 'qrcode'
import $ from 'jquery'
import { mapGetters } from 'vuex'

export default {
  name: '', // 离线合同
  data() {
    return {
      showMaterialTable: true,
      loading1: false,
      title2: '',
      purchaseStateValue: 2, // 采购状态 全部
      purchaseState: [
        {
          label: '未采购',
          value: 1
        }, {
          label: '全部',
          value: 2
        }
      ],
      check1: 0,
      check2: 0,
      check3: 0,
      check4: 0,
      materialName: '',
      inventoryStateValue: '', // 库存状态
      inventoryState: [
        {
          label: '充足',
          value: 2
        },
        {
          label: '不足',
          value: 1
        }
      ],
      tableData1: [],
      pageCurrent1: 1,
      pageSize1: 10,
      total1: 0,
      offlineContractNum: '', // 离线合同流水号
      offlineContract: '', // 离线合同号
      supplierName0: '', // 供应商名称（外面的）
      supplierName: '', // 供应商名称
      payTime: [], // 付款时间节点
      tableData2: [],
      total2: 0,
      pageCurrent2: 1,
      pageSize2: 10,
      dialogVisible1: false,
      form1: {},
      supplierCheck1: 0,
      supplierCheck2: 0,
      supplierCheck3: 0,
      supplierCheck4: 0,
      supplierCheck5: 0,
      supplierCheck6: 0,
      supplierCheck7: 0,
      supplierCheck8: 0,
      supplierCheck9: 0,
      supplierCheck10: 0,
      supplierCheck11: 0,
      supplierCheck12: 0,
      supplierValue: '', // 供应商流水号
      goodTime: '', // 货期
      enterpriseNature: '', // 企业性质
      createDate: '', // 创立日期
      registeredCapital: '', // 注册资本
      taxNum: '', // 税号
      EMail: '', // 电子邮箱
      address: '', // 地址
      account: '', // 账号
      openingBank: '', // 开户行
      phone: '', // 电话号码
      fax: '', // 传真
      tableData01: [],
      dialogVisible2: false,
      form2: {
        离线合同流水号: '',
        离线合同编号: '',
        离线合同名称: '',
        供应商流水号: '',
        供应商名称: '',
        规定到货时间: '',
        离线合同备注: '付款方式：；付款时间：；到货时间：；开票信息：；其他说明：；'
      },
      rules2: { // 离线合同表单验证规则
        离线合同编号: [{ required: true, message: '请填写离线合同编号' }],
        离线合同名称: [{ required: true, message: '请填写离线合同名称' }],
        供应商名称: [{ required: true, message: '请选择供应商' }],
        规定到货时间: [{ required: true, message: '请选择规定到货时间' }],
        运费: [{ required: true, message: '请填写运费' }],
        付款方式: [{ required: true, message: '请选择付款方式' }]
      },
      tableData3: [],
      materielGroup: [], // 物料流水号组
      partGroup: [], // 离线合同明细流水号组
      numGroup: [], // 数量组
      priceGroup: [], // 单价组
      totalPrice: 0, // 合同总额
      tableData4: [], // 合同模板
      stipulateArrivalTime: '', // 规定到货时间
      离线合同状态: '',
      paramRow: '', // 参数row
      disable: true // 其他的禁用
    }
  },
  computed: {
    ...mapGetters([
      'sidebar',
      'avatar',
      'name',
      'id' // 人员编号
    ])
  },
  created() {
    this.fetchData()
    this.searchTable1()
    this.searchTable2()
  },
  methods: {
    useqrcode(contractNum) {
      const opts = {
        errorCorrectionLevel: 'H',
        type: 'image/jpeg',
        rendererOpts: {
          quality: 0.3
        }
      }
      QRCode.toDataURL(contractNum, opts, function(err, url) {
        if (err) throw err
        const img = document.getElementById('img')
        img.src = url
      })
    },
    fetchData() {},
    searchTable1() { // 查询物料库物料
      this.loading1 = true
      this.materialName ? this.check1 = 1 : this.check1 = 0
      this.inventoryStateValue ? this.check2 = 1 : this.check2 = 0
      searchInventoryNum(this.pageCurrent1, this.pageSize1, this.check1, this.materialName, this.check2, this.inventoryStateValue, this.purchaseStateValue).then(response => {
        this.tableData1 = response.data.rows
        this.tableData1.map(v => {
          this.$set(v, 'changeSafeValue', false)
          v.原安全库存量 = v.安全库存量
          return v
        })
        this.total1 = response.data.total
        this.loading1 = false
      })
    },
    handleSizeChange1(val) {
      this.pageSize1 = val
      this.pageCurrent1 = 1
      this.searchTable1()
    },
    handleCurrentChange1(val) {
      this.pageCurrent1 = val
      this.searchTable1()
    },
    handleSelectionChange(val) {
      this.materielGroup = []
      for (let i = 0; i < val.length; i++) {
        this.materielGroup.push(val[i].物料流水号)
      }
    },
    cancelEdit(row) { // 取消设置
      row.安全库存量 = row.原安全库存量
      row.changeSafeValue = false
      this.$message('取消修改')
    },
    confirmEdit(row) { // 确认设置
      Number(row.安全库存量) ? row.安全库存量 = Number(row.安全库存量) : row.安全库存量 = 0
      setSafeValue(row.物料流水号, parseInt(row.安全库存量)).then(response => {
        if (response.data[0].result === '1') {
          row.changeSafeValue = false
          this.$message.success('设置成功')
          this.searchTable1()
        } else {
          this.$message.error('设置失败')
        }
      })
    },
    searchTable2() { // 查询离线合同列表
      this.offlineContract ? this.check3 = 1 : this.check3 = 0
      this.supplierName0 ? this.check4 = 1 : this.check4 = 0
      searchOfflineContract(this.pageCurrent2, this.pageSize2, this.check3, this.offlineContract, this.check4, this.supplierName0).then(response => {
        this.tableData2 = response.data.rows
        this.total2 = response.data.total
      })
    },
    handleSizeChange2(val) { // 离线合同列表分页
      this.pageSize2 = val
      this.searchTable2()
    },
    handleCurrentChange2(val) { // 离线合同列表分页
      this.pageCurrent2 = val
      this.searchTable2()
    },
    addOfflineContract() { // 创建离线合同
      if (this.$refs['form2'] !== undefined) {
        this.$refs['form2'].resetFields()
      }
      this.title2 = '创建离线合同'
      this.form2.离线合同编号 = ''
      this.form2.离线合同名称 = ''
      this.form2.供应商流水号 = ''
      this.form2.供应商名称 = ''
      this.form2.规定到货时间 = ''
      this.form2.离线合同备注 = '付款方式：；付款时间：；到货时间：；开票信息：；其他说明：；'
      this.dialogVisible2 = true
    },
    submitAddOfflineContract() { // 新建离线合同
      this.$refs['form2'].validate((valid) => {
        if (valid) {
          const numGroup1 = [] // 空数组，放现有的询价单号
          searchOfflineContract2().then(response => { // 先查询判断是否存在
            for (let i = 0; i < response.data.length; i++) {
              numGroup1.push(response.data[i].离线合同编号)
            }
          }).then(() => {
            if (numGroup1.indexOf(this.form2.离线合同编号) !== -1) {
              this.$message.error('该离线合同编号已存在')
            } else {
              addOfflineContract(this.form2.离线合同编号, this.form2.离线合同名称, this.form2.供应商流水号, this.id, this.form2.规定到货时间, this.form2.离线合同备注).then(response => {
                if (response.data[0].result === '1') {
                  this.$message.success('新建离线合同成功')
                  this.searchTable2()
                  this.dialogVisible2 = false
                } else { this.$message.error('新建离线合同失败') }
              })
            }
          })
        } else {
          console.log('error submit!!')
          return false
        }
      })
    },
    editOfflineContract(row) {
      if (this.$refs['form2'] !== undefined) {
        this.$refs['form2'].resetFields()
      }
      this.title2 = '编辑离线合同'
      this.form2.离线合同流水号 = row.离线合同流水号
      this.form2.离线合同编号 = row.离线合同编号
      this.form2.离线合同名称 = row.离线合同名称
      this.form2.供应商流水号 = row.供应商流水号
      this.form2.供应商名称 = row.供应商名称
      this.form2.规定到货时间 = row.规定到货时间
      this.form2.离线合同备注 = row.离线合同备注
      this.dialogVisible2 = true
    },
    submitEditOfflineContract() {
      this.$refs['form2'].validate((valid) => {
        if (valid) {
          const numGroup1 = [] // 空数组，放现有的离线合同号
          const numGroup2 = [] // 空数组，放现有的离线合同流水号
          searchOfflineContract2().then(response => { // 先查询判断是否存在
            for (let i = 0; i < response.data.length; i++) {
              numGroup1.push(response.data[i].离线合同编号)
              numGroup2.push(response.data[i].离线合同流水号)
            }
          }).then(() => {
            if (numGroup1.indexOf(this.form2.离线合同编号) !== -1 && numGroup1.indexOf(this.form2.离线合同编号) !== numGroup2.indexOf(parseInt(this.form2.离线合同流水号))) {
              this.$message.error('该离线合同编号已存在')
            } else {
              editOfflineContract(this.form2.离线合同流水号, this.form2.离线合同编号, this.form2.离线合同名称, this.form2.供应商流水号, this.id, this.form2.规定到货时间, this.form2.离线合同备注).then(response => {
                if (response.data[0].result === '1') {
                  this.$message.success('修改离线合同成功')
                  this.searchTable2()
                  this.dialogVisible2 = false
                } else { this.$message.error('修改离线合同失败') }
              })
            }
          })
        } else {
          console.log('error submit!!')
          return false
        }
      })
    },
    deleteOfflineContract(row) { // 删除离线合同
      this.$confirm('确定删除该合同?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        deleteOfflineContract(row.离线合同流水号).then(response => {
          if (response.data[0].result === '1') {
            this.$message.success('删除成功')
            this.searchTable2()
            this.disable = true
            searchMateriel(this.offlineContractNum).then(response => {
              this.tableData3 = response.data
            })
          } else { this.$message.error('数据占用，删除失败') }
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消删除'
        })
      })
    },
    searchSupplier() { // 查询创立日期和注册资本大于符合条件的数据
      this.supplierName ? this.supplierCheck1 = 1 : (this.supplierCheck1 = 0, this.supplierName = '')
      this.enterpriseNature ? this.supplierCheck2 = 1 : (this.supplierCheck2 = 0, this.enterpriseNature = '')
      this.createDate ? this.supplierCheck3 = 1 : (this.supplierCheck3 = 0, this.createDate = '')
      this.registeredCapital ? this.supplierCheck4 = 1 : (this.supplierCheck4 = 0, this.registeredCapital = '')
      this.taxNum ? this.supplierCheck5 = 1 : (this.supplierCheck5 = 0, this.taxNum = '')
      this.EMail ? this.supplierCheck6 = 1 : (this.supplierCheck6 = 0, this.EMail = '')
      this.address ? this.supplierCheck7 = 1 : (this.supplierCheck7 = 0, this.address = '')
      this.account ? this.supplierCheck8 = 1 : (this.supplierCheck8 = 0, this.account = '')
      this.openingBank ? this.supplierCheck9 = 1 : (this.supplierCheck9 = 0, this.openingBank = '')
      this.phone ? this.supplierCheck10 = 1 : (this.supplierCheck10 = 0, this.phone = '')
      this.fax ? this.supplierCheck11 = 1 : (this.supplierCheck11 = 0, this.fax = '')
      this.goodTime ? this.supplierCheck12 = 1 : (this.supplierCheck12 = 0, this.goodTime = '')
      searchSupplier(this.supplierCheck1, this.supplierName, this.supplierCheck2, this.enterpriseNature, this.supplierCheck3, this.createDate, this.supplierCheck4, this.registeredCapital, this.supplierCheck5, this.taxNum, this.supplierCheck6, this.EMail, this.supplierCheck7, this.address, this.supplierCheck8, this.account, this.supplierCheck9, this.openingBank, this.supplierCheck10, this.phone, this.supplierCheck11, this.fax, this.supplierCheck12, this.goodTime).then(response => {
        this.tableData01 = response.data
      })
    },
    showSupplierDetail(row) {
      this.form2.供应商流水号 = row.供应商流水号
      this.form2.供应商名称 = row.供应商名称
      this.supplierValue = row.供应商流水号
      this.supplierName = row.供应商名称
      this.enterpriseNature = row.企业性质
      this.createDate = row.创立日期
      this.registeredCapital = row.注册资本
      this.taxNum = row.税号
      this.EMail = row.电子信箱
      this.address = row.地址
      this.account = row.帐号
      this.openingBank = row.开户行
      this.phone = row.电话号码
      this.fax = row.传真
      this.goodTime = row.货期
    },
    emptySupplierDetail() {
      this.supplierValue = ''
      this.supplierName = ''
      this.enterpriseNature = ''
      this.createDate = ''
      this.registeredCapital = ''
      this.taxNum = ''
      this.EMail = ''
      this.address = ''
      this.account = ''
      this.openingBank = ''
      this.phone = ''
      this.fax = ''
      this.goodTime = ''
    },
    submitSelectSupplier() { // 确定选择供应商
      this.dialogVisible1 = false
    },
    searchTable3(row) { // 查询离线合同明细
      this.stipulateArrivalTime = row.规定到货时间.split(' ')[0]
      this.offlineContractNum = row.离线合同流水号
      this.离线合同状态 = row.离线合同状态
      searchMateriel(this.offlineContractNum).then(response => {
        this.tableData3 = response.data
      })
      Number(row.离线合同状态) !== 1 ? this.disable = true : this.disable = false // 是否为编辑模式
    },
    getSummaries(param) { // 合计
      const { columns, data } = param
      const sums = []
      columns.forEach((column, index) => {
        if (index === 0) {
          sums[index] = '总价'
        } else if (index === 7) {
          const values = data.map(item => Number(parseFloat(item['单价']) * parseInt(item['数量'])))
          if (!values.every(value => isNaN(value))) {
            sums[index] = values.reduce((prev, curr) => {
              const value = Number(curr)
              if (!isNaN(value)) {
                return Number((prev + curr).toFixed(2))
              } else {
                return Number((prev).toFixed(2))
              }
            }, 0)
            sums[index] += ' 元'
          } else {
            sums[index] = 'N/A'
          }
        }
      })
      return sums
    },
    addMateriel() { // 将物料选入离线合同
      if (!this.offlineContractNum) {
        this.$message.warning('请选择离线合同')
      } else if (Number(this.离线合同状态) !== 1) {
        this.$message.warning('请选择可编辑的离线合同')
      } else if (this.materielGroup.length === 0) {
        this.$message.warning('请勾选物料')
      } else {
        addMateriel(this.offlineContractNum, this.materielGroup).then(response => {
          if (response.data[0].result === '1') {
            this.$message.success('选入成功')
            searchMateriel(this.offlineContractNum).then(response => {
              this.tableData3 = response.data
            })
          } else { this.$message.error('选入失败') }
        })
      }
    },
    deleteMateriel(row) { // 移除物料
      this.$confirm('确定移除该物料?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        deleteMateriel(row.离线合同明细流水号).then(response => {
          if (response.data[0].result === '1') {
            this.$message.success('移除成功')
            searchMateriel(this.offlineContractNum).then(response => {
              this.tableData3 = response.data
            })
          } else { this.$message.error('移除失败') }
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消移除'
        })
      })
    },
    saveContract() {
      this.$confirm('确定保存合同?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        this.totalPrice = 0
        this.partGroup = []
        this.numGroup = []
        this.priceGroup = []
        const dateGroup = []
        const remarkGroup = []
        for (let i = 0; i < this.tableData3.length; i++) {
          this.totalPrice += this.tableData3[i].数量 * this.tableData3[i].单价
          this.partGroup.push(this.tableData3[i].离线合同明细流水号)
          this.numGroup.push(this.tableData3[i].数量)
          this.priceGroup.push(this.tableData3[i].单价)
          dateGroup.push(this.tableData3[i].交货期要求)
          remarkGroup.push(this.tableData3[i].备注)
        }
        saveOfflineContact(this.offlineContractNum, this.totalPrice, this.partGroup, this.numGroup, this.priceGroup, dateGroup, remarkGroup).then(response => {
          if (response.data[0].result === '1') {
            this.$message.success('离线合同保存成功')
            this.searchTable2()
            searchMateriel(this.offlineContractNum).then(response => {
              this.tableData3 = response.data
            })
          } else { this.$message.error('离线合同保存失败') }
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消操作'
        })
      })
    },
    doneOfflineContact() { // 生成离线合同
      this.$confirm('确定生成合同?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        this.totalPrice = 0
        this.partGroup = []
        this.numGroup = []
        this.priceGroup = []
        const dateGroup = []
        const remarkGroup = []
        for (let i = 0; i < this.tableData3.length; i++) {
          this.totalPrice += this.tableData3[i].数量 * this.tableData3[i].单价
          this.partGroup.push(this.tableData3[i].离线合同明细流水号)
          this.numGroup.push(this.tableData3[i].数量)
          this.priceGroup.push(this.tableData3[i].单价)
          dateGroup.push(this.tableData3[i].交货期要求)
          remarkGroup.push(this.tableData3[i].备注)
        }
        doneOfflineContact(this.offlineContractNum, this.totalPrice, this.partGroup, this.numGroup, this.priceGroup, dateGroup, remarkGroup).then(response => {
          if (response.data[0].result === '1') {
            this.$message.success('离线合同生成成功')
            this.searchTable2()
            searchMateriel(this.offlineContractNum).then(response => {
              this.tableData3 = response.data
              this.disable = true // 是否为编辑模式
            })
          } else { this.$message.error('离线合同生成失败') }
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消操作'
        })
      })
    },
    exportExcel(row) {
      this.$confirm('确定导出该合同?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        const children = document.getElementsByClassName('tableData')
        const parent = document.getElementsByClassName('offlineContract')[0]
        if (children.length !== 0) {
          for (let i = children.length - 1; i >= 0; i--) {
            parent.removeChild(children[i])
          }
        }
        const tr = []
        let length = 0
        this.tableData3.length < 15 ? length = 15 : length = this.tableData3.length
        for (let i = 0; i < length; i++) {
          tr[i] = document.createElement('tr')
          tr[i].setAttribute('class', 'tableData')
          tr[i].innerHTML = `<td style="height: 40px"/><td colspan="2" style="height: 40px"/><td style="height: 40px"/><td colspan="2" style="height: 40px"/><td style="height: 40px"/><td colspan="2" style="height: 40px"/><td colspan="2" style="height: 40px"/><td style="height: 40px"/><td colspan="2" style="height: 40px"/>`
          document.getElementById('tablehead').after(tr[i])
        }
        let total = 0
        for (let j = 0; j < this.tableData3.length; j++) {
          document.getElementsByClassName('tableData')[j].children[0].innerHTML = j + 1
          document.getElementsByClassName('tableData')[j].children[1].innerHTML = this.tableData3[j].物料名称
          document.getElementsByClassName('tableData')[j].children[2].innerHTML = this.tableData3[j].物料规格
          document.getElementsByClassName('tableData')[j].children[3].innerHTML = this.tableData3[j].物料型号
          document.getElementsByClassName('tableData')[j].children[4].innerHTML = this.tableData3[j].数量
          document.getElementsByClassName('tableData')[j].children[5].innerHTML = this.tableData3[j].单价
          document.getElementsByClassName('tableData')[j].children[6].innerHTML = (this.tableData3[j].数量 * this.tableData3[j].单价).toFixed(2)
          document.getElementsByClassName('tableData')[j].children[7].innerHTML = this.tableData3[j].交货期要求
          document.getElementsByClassName('tableData')[j].children[8].innerHTML = this.tableData3[j].备注
          total += Number(this.tableData3[j].数量 * this.tableData3[j].单价)
        }
        total = total.toFixed(2)
        document.getElementById('contractNum').innerHTML = row.离线合同编号
        document.getElementById('contractName').innerHTML = row.离线合同名称
        document.getElementById('supplier').innerHTML = row.供应商名称
        document.getElementById('buyer').innerHTML = row.采购员
        document.getElementById('total').innerHTML = total
        document.getElementById('remark').innerHTML = row.离线合同备注
        $('#qrCode').html(`<img id="img" style="display: block;margin: 0 auto">`)
        this.useqrcode(row.离线合同流水号) // 显示二维码
      }).then(() => {
        const htmlNode = $('#offlineContract').html()
        const body = $('body').attr('style', 'padding: 20px;margin: 0 auto;display: block;width: 800px;background: #fff;')
        body.children().hide()
        const printNode = $(htmlNode)
        body.append(printNode)
        window.print()
        body.removeAttr('style')
        body.children().not('script').show()
        body.children().not('#app').hide()
        printNode.remove()
      }).catch(res => {
        console.log(res)
        this.$message({
          type: 'info',
          message: '已取消操作'
        })
      })
    }
  }
}
</script>

<style scoped>
  .offlineContract td{
    height: 40px;
    text-align: center;
  }
  .el-card{
    margin-bottom: 15px;
  }
  .el-date-editor{
    width:150px;
  }
  .el-select{
    width:200px
  }
  .el-input{
    width:200px
  }
  span{
    margin: 10px 0 10px 10px;
  }
  .el-tag{
    margin: 0
  }
  .searchForm .el-form-item{
    margin-bottom: 5px;
  }
  .edit-input {
    padding-right: 100px;
  }
  .cancel-btn {
    position: absolute;
    right: 15px;
    top: 5px;
  }
</style>
